Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/CharacterRange.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/CharacterRange.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/CharacterRange.ab	(revision 635)
@@ -1,3 +1,6 @@
 ' Classes/System/Drawing/CharacterRange.ab
+
+Namespace System
+Namespace Drawing
 
 Class CharacterRange
@@ -49,2 +52,5 @@
 	length As Long
 End Class
+
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Color.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Color.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Color.ab	(revision 635)
@@ -1,5 +1,6 @@
 ' Classes/System/Drawing/Color.ab
 
-#require <Classes/System/Drawing/Imaging/misc.ab>
+Namespace System
+Namespace Drawing
 
 Class Color
@@ -21,5 +22,5 @@
 	End Sub
 
-	Sub Color(newArgb As ARGB)
+	Sub Color(newArgb As System.Drawing.Imaging.ARGB)
 		argb = newArgb
 	End Sub
@@ -34,24 +35,24 @@
 
 	Function A() As Byte
-		A = (argb >> ALPHA_SHIFT) As Byte
+		A = (argb >> System.Drawing.Imaging.ALPHA_SHIFT) As Byte
 	End Function
 
 	Function R() As Byte
-		R = (argb >> RED_SHIFT) As Byte
+		R = (argb >> System.Drawing.Imaging.RED_SHIFT) As Byte
 	End Function
 
 	Function G() As Byte
-		G = (argb >> GREEN_SHIFT) As Byte
+		G = (argb >> System.Drawing.Imaging.GREEN_SHIFT) As Byte
 	End Function
 
 	Function B() As Byte
-		B = (argb >> BLUE_SHIFT) As Byte
-	End Function
-
-	Function Value() As ARGB
+		B = (argb >> System.Drawing.Imaging.BLUE_SHIFT) As Byte
+	End Function
+
+	Function Value() As System.Drawing.Imaging.ARGB
 		Value = argb
 	End Function
 
-	Sub Value(value As ARGB)
+	Sub Value(value As System.Drawing.Imaging.ARGB)
 		argb = value
 	End Sub
@@ -73,5 +74,5 @@
 	End Function
 */
-	Static Function FromArgb(argb As ARGB) As Color
+	Static Function FromArgb(argb As System.Drawing.Imaging.ARGB) As Color
 		Return New Color(argb)
 	End Function
@@ -296,12 +297,15 @@
 	End Enum
 */
-	Static Function MakeARGB(a As Byte, r As Byte, g As Byte, b As Byte) As ARGB
-		MakeARGB = (((b As ARGB) <<  BLUE_SHIFT) Or _
-		            ((g As ARGB) << GREEN_SHIFT) Or _
-		            ((r As ARGB) <<   RED_SHIFT) Or _
-		            ((a As ARGB) << ALPHA_SHIFT))
+	Static Function MakeARGB(a As Byte, r As Byte, g As Byte, b As Byte) As System.Drawing.Imaging.ARGB
+		MakeARGB = (((b As System.Drawing.Imaging.ARGB) <<  System.Drawing.Imaging.BLUE_SHIFT) Or _
+		            ((g As System.Drawing.Imaging.ARGB) << System.Drawing.Imaging.GREEN_SHIFT) Or _
+		            ((r As System.Drawing.Imaging.ARGB) <<   System.Drawing.Imaging.RED_SHIFT) Or _
+		            ((a As System.Drawing.Imaging.ARGB) << System.Drawing.Imaging.ALPHA_SHIFT))
 	End Function
 
 Protected
-	argb As ARGB
+	argb As System.Drawing.Imaging.ARGB
 End Class
+
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/Matrix.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/Matrix.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/Matrix.ab	(revision 635)
@@ -1,4 +1,11 @@
 ' Classes/System/Drawing/Drawing2D/Matrix.ab
+Namespace System
+Namespace Drawing
+Namespace Drawing2D
 
 Class Matrix
 End Class
+
+End Namespace
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/misc.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/misc.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/misc.ab	(revision 635)
@@ -1,3 +1,6 @@
 ' Classes/System/Drawing/Drawing2D/misc.ab
+Namespace System
+Namespace Drawing
+Namespace Drawing2D
 
 Enum CombineMode
@@ -81,2 +84,6 @@
 	Device
 End Enum
+
+End Namespace
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Font.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Font.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Font.ab	(revision 635)
@@ -1,8 +1,10 @@
+Namespace System
+Namespace Drawing
+
+
 /**
 @file Classes/System/Drawing/Font.ab
 @brief Fontクラスなどの実装。
 */
-
-#require <Classes/System/Drawing/Graphics.ab>
 
 Class FontFamily : End Class
@@ -329,2 +331,5 @@
 	/*mutable*/ lastResult As Status
 End Class
+
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Graphics.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Graphics.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Graphics.ab	(revision 635)
@@ -1,3 +1,6 @@
 ' Classes/System/Drawing/Graphics.ab
+
+Namespace System
+Namespace Drawing
 
 Class Brush : End Class
@@ -2008,2 +2011,4 @@
 End Class
 
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Image.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Image.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Image.ab	(revision 635)
@@ -1,3 +1,6 @@
 ' Classes/System/Drawing/Image.ab
+
+Namespace System
+Namespace Drawing
 
 Class Image
@@ -9,2 +12,5 @@
 	nativeImage As *GpImage
 End Class
+
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/MetafileHeader.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/MetafileHeader.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/MetafileHeader.ab	(revision 635)
@@ -1,3 +1,6 @@
 ' Classes/System/Drawing/Imaging/MetafileHeader.ab
+Namespace System
+Namespace Drawing
+Namespace Imaging
 
 Type Align(8) ENHMETAHEADER3
@@ -151,2 +154,6 @@
 	End Function
 End Class
+
+End Namespace
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/misc.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/misc.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/misc.ab	(revision 635)
@@ -1,5 +1,7 @@
 ' Classes/System/Drawing/Imaging/misc.ab
 
-#require <Classes/System/Drawing/Color.ab>
+Namespace System
+Namespace Drawing
+Namespace Imaging
 
 TypeDef ARGB = DWord
@@ -433,2 +435,6 @@
 	ColorChannelLast
 End Enum
+
+End Namespace
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Text/misc.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Text/misc.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Text/misc.ab	(revision 635)
@@ -1,3 +1,6 @@
 ' Classes/System/Drawing/Text/misc.ab
+Namespace System
+Namespace Drawing
+Namespace Text
 
 Enum TextRenderingHint
@@ -9,2 +12,6 @@
 	ClearTypeGridFit
 End Enum
+
+End Namespace
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/misc.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/misc.ab	(revision 550)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/misc.ab	(revision 635)
@@ -1,6 +1,6 @@
 ' Classes/System/Drawing/misc.ab
 
-#ifndef __SYSTEM_DRAWING_MISC_AB__
-#define __SYSTEM_DRAWING_MISC_AB__
+Namespace System
+Namespace Drawing
 
 Enum RotateFlipType
@@ -47,3 +47,4 @@
 
 
-#endif '__SYSTEM_DRAWING_MISC_AB__
+End Namespace
+End Namespace